unit gp;
interface
procedure Graphica;
type
 TGraphObj = object
 private
  x,y:integer;
  color:word;
  procedure Draw(color0:word);virtual;
 public
  constructor Kstr;
  procedure Init(x0,y0:integer;color0:word);
  procedure Show;
  procedure Hide;
  procedure MoveTo(x1,y1:integer);
end;
 TPoint = object(TGraphObj)
 private
  procedure Draw(color0:word);virtual;
 end;
 TLine = object(TGraphObj)
 procedure Init(xn,yn,xk,yk:integer;color0:word);
 private
  dx,dy:integer;
  procedure Draw(color0:word);virtual;
 end;
 TCircle = object(TGraphObj)
 procedure Init(x0,y0,r:integer;color0:word);
 private
  radius:integer;
  procedure Draw(color0:word);virtual;
 end;
 TRect = object(TLine)
 private
  procedure Draw(color0:word);virtual;
 end;
 TTri = object(TGraphObj)
 procedure Init(x0,y0,x1,y1,x2,y2:integer;color0:word);
 private
  dx1,dy1,dx2,dy2:integer;
  procedure Draw(color0:word);virtual;
 end;
 TBar3D = object(TRect)
 procedure Init(x0,y0,x1,y1:integer;d:integer;color0:word);
 private
  depth:integer;
  procedure Draw(color0:word);virtual;
 end;

implementation
 uses graph;
 procedure Graphica;
 var driver,mode:integer;
  begin
   driver:=Detect; InitGraph(driver,mode,'\bp\bgi');
  end;
 constructor TGraphObj.Kstr;
  begin
  end;
 procedure TGraphObj.Init;
  begin
   x:=x0;y:=y0;color:=color0;
  end;
 procedure TGraphObj.Draw;
  begin
  end;
 procedure TGraphObj.Show;
  begin
   Draw(color)
  end;
 procedure TGraphObj.Hide;
  begin
   Draw(GetBkColor)
  end;
 procedure TGraphObj.MoveTo;
  begin
   Hide;
   x:=x1;y:=y1;
   Show
  end;
 procedure TPoint.Draw;
  begin
   PutPixel(x,y,color0)
  end;
 procedure TLine.Init;
  begin
   inherited Init(xn,yn,color0);
   dx:=xk-xn; dy:=yk-yn;
  end;
 procedure TLine.Draw;
  begin
   SetColor(color0);
   Line(x,y,x+dx,y+dy);
  end;
 procedure TCircle.Init;
  begin
   inherited Init(x0,y0,color0);
   radius:=r;
  end;
 procedure TCircle.Draw;
  begin
   SetColor(color0);
   Circle(x,y,radius);
   SetFillStyle(1,color0);
   FloodFill(x,y,color0)
  end;
 procedure TRect.Draw;
  begin
   SetColor(color0);
   SetFillStyle(1,color0);
   Bar(x,y,x+dx,y+dy)
  end;
 procedure TTri.Init;
  begin
   TGraphObj.Init(x0,y0,color0);
   dx1:=x1-x0; dy1:=y1-y0; dx2:=x2-x1; dy2:=y2-y1;
  end;
 procedure TTri.Draw;
 var xp,yp:integer;
  begin
   SetColor(color0);
   Graph.MoveTo(x,y); LineRel(dx1,dy1); LineRel(dx2,dy2); LineTo(x,y);
   SetFillStyle(1,color0);
   xp:=round((2*x+dx1+dx2/2)/2);
   yp:=round((2*y+dy1+dy2/2)/2);
   FloodFill(xp,yp,color0)
  end;
 procedure TBar3D.Init;
  begin
   inherited Init(x0,y0,x1,y1,color0);
   depth:=d;
  end;
 procedure TBar3D.Draw;
  begin
   SetColor(color0);
   SetFillStyle(2,color0);
   Bar3D(x,y,x+dx,y+dy,depth,true)
  end;

  begin
  end.